### org.jfree.layouting.output

# Class ChainingOutputProcessor

- `java.lang.Object`
- - `org.jfree.layouting.output.ChainingOutputProcessor`

Implemented Interfaces:
  OutputProcessor

`public class ChainingOutputProcessor`
`extends java.lang.Object`
`implements OutputProcessor`

Creation-Date: 16.06.2006, 14:44:55

Author:
  Thomas Morgner

  ## Constructor Summary

  `ChainingOutputProcessor(OutputProcessor outputProcessor)`

  ## Method Summary

  `InputFeed`

  `createInputFeed(LayoutProcess layoutProcess)`

  `ModelBuilder`

  `createModelBuilder(LayoutProcess layoutProcess)`
    The model builder normalizes the input and builds the Display-Model.

  `Normalizer`

  `createNormalizer(LayoutProcess layoutProcess)`
    Returns the content normalizer implementation for this OP.

  `Renderer`

  `createRenderer(LayoutProcess layoutProcess)`

  `Configuration`

  `getConfiguration()`

  `LogicalPageKey`

  `getLogicalPage(int page)`

  `int`

  `getLogicalPageCount()`

  `OutputProcessorMetaData`

  `getMetaData()`

  `int`

  `getPageCursor()`

  `boolean`

  `isContentGeneratable()`
    This flag indicates, whether the output processor has collected enough information to start the content generation.

  `boolean`

  `isGlobalStateComputed()`
    This flag indicates, whether the global content has been computed.

  `boolean`

  `isPaginationFinished()`
    Checks, whether the 'processingFinished' event had been received at least once.

  `void`

  `processContent(LogicalPageBox logicalPage)`

  `void`

  `processDocumentMetaData(DocumentContext documentContext)`

  `void`

  `processingFinished()`
    Notifies the output processor, that the processing has been finished and that the input-feed received the last event.

  `void`

  `setPageCursor(int cursor)`

## Constructor Details

### ChainingOutputProcessor

    public ChainingOutputProcessor(OutputProcessor outputProcessor)

## Method Details

### createInputFeed

    public InputFeed createInputFeed(LayoutProcess layoutProcess)

> Specified by:
>   createInputFeed in interface OutputProcessor

### createModelBuilder

    public ModelBuilder createModelBuilder(LayoutProcess layoutProcess)

> The model builder normalizes the input and builds the Display-Model. The DisplayModel enriches and normalizes the logical document model so that it is better suited for rendering.
> Specified by:
>   createModelBuilder in interface OutputProcessor
> Parameters:
>   `layoutProcess` - the layout process that governs all.
> Returns:
>   the created model builder.

### createNormalizer

    public Normalizer createNormalizer(LayoutProcess layoutProcess)

> Returns the content normalizer implementation for this OP. The content normalizer is responsible for resolving the styles and for initiating the display model building.
> Specified by:
>   createNormalizer in interface OutputProcessor
> Parameters:
>   `layoutProcess` - the layout process that governs all.
> Returns:
>   the created content normalizer.

### createRenderer

    public Renderer createRenderer(LayoutProcess layoutProcess)

> Specified by:
>   createRenderer in interface OutputProcessor

### getConfiguration

    public Configuration getConfiguration()

> Specified by:
>   getConfiguration in interface OutputProcessor

### getLogicalPage

    public LogicalPageKey getLogicalPage(int page)

> Specified by:
>   getLogicalPage in interface OutputProcessor

### getLogicalPageCount

    public int getLogicalPageCount()

> Specified by:
>   getLogicalPageCount in interface OutputProcessor

### getMetaData

    public OutputProcessorMetaData getMetaData()

> Specified by:
>   getMetaData in interface OutputProcessor

### getPageCursor

    public int getPageCursor()

> Specified by:
>   getPageCursor in interface OutputProcessor

### isContentGeneratable

    public boolean isContentGeneratable()

> This flag indicates, whether the output processor has collected enough information to start the content generation.
> Specified by:
>   isContentGeneratable in interface OutputProcessor
> Returns:

### isGlobalStateComputed

    public boolean isGlobalStateComputed()

> This flag indicates, whether the global content has been computed. Global content consists of global counters (except the pages counter) and derived information like table of contents, the global directory of images or tables etc.

> The global state must be computed before paginating can be attempted (if the output target is paginating at all).
> Specified by:
>   isGlobalStateComputed in interface OutputProcessor
> Returns:
>   true, if the global state has been computed, false otherwise.

### isPaginationFinished

    public boolean isPaginationFinished()

> Checks, whether the 'processingFinished' event had been received at least once.
> Specified by:
>   isPaginationFinished in interface OutputProcessor
> Returns:

### processContent

    public void processContent(LogicalPageBox logicalPage)

> Specified by:
>   processContent in interface OutputProcessor

### processDocumentMetaData

    public void processDocumentMetaData(DocumentContext documentContext)

> Specified by:
>   processDocumentMetaData in interface OutputProcessor

### processingFinished

    public void processingFinished()

> Notifies the output processor, that the processing has been finished and that the input-feed received the last event.
> Specified by:
>   processingFinished in interface OutputProcessor

### setPageCursor

    public void setPageCursor(int cursor)

> Specified by:
>   setPageCursor in interface OutputProcessor